#ifdef INPUT_IS_OES_TEXTURE 
#extension GL_OES_EGL_image_external : require 
uniform samplerExternalOES u_texture0; 
#else 
uniform sampler2D u_texture0; 
#endif 

precision highp float;

uniform vec2 u_v2ViewDimension;
uniform vec2 u_v2FocusDimensionSqr;
uniform vec2 u_v2FocusCenter;
uniform float u_Depth;

varying vec2 v_texCoords;

void main()
{
    vec4 v4Src = texture2D(u_texture0, v_texCoords);
    v4Src.a = 1.0;

    vec2 v2Dis = (v_texCoords - u_v2FocusCenter) * u_v2ViewDimension;
    v2Dis = v2Dis * v2Dis / u_v2FocusDimensionSqr;
    float fRatio = v2Dis.x + v2Dis.y;

    if(fRatio > u_Depth)
    {
        float fGrey = dot(v4Src, vec4(0.257, 0.504, 0.098, 0.062745));
        gl_FragColor = vec4(fGrey, fGrey, fGrey, 1.0);
    }
    else if(fRatio >= 1.0)
    {
        float fGrey = dot(v4Src, vec4(0.257, 0.504, 0.098, 0.062745));
        float fSat = (fRatio - 1.0) / (u_Depth - 1.0);
        gl_FragColor = mix(v4Src, vec4(fGrey, fGrey, fGrey, 1.0), fSat);
    }
    else
        gl_FragColor = v4Src;
}