attribute vec4 a_position;
attribute vec2 a_texCoords;
uniform mat4 u_MMatrix;
uniform mat4 u_VMatrix;
uniform mat4 u_PMatrix;

uniform float texelWidthOffset;
uniform float texelHeightOffset;

varying vec2 blurCoordinates[9];
uniform float iDegree;

void main()
{
	gl_Position = u_PMatrix * u_VMatrix * u_MMatrix * a_position;
	
	vec2 singleStepOffset = vec2(texelWidthOffset, texelHeightOffset) * iDegree * 0.1;
	blurCoordinates[0] = a_texCoords;
	blurCoordinates[1] = a_texCoords + singleStepOffset * 1.0;
	blurCoordinates[2] = a_texCoords - singleStepOffset * 1.0;
	blurCoordinates[3] = a_texCoords + singleStepOffset * 2.0;
	blurCoordinates[4] = a_texCoords - singleStepOffset * 2.0;
	blurCoordinates[5] = a_texCoords + singleStepOffset * 3.0;
	blurCoordinates[6] = a_texCoords - singleStepOffset * 3.0;
	blurCoordinates[7] = a_texCoords + singleStepOffset * 4.0;
	blurCoordinates[8] = a_texCoords - singleStepOffset * 4.0;
}