
uniform sampler2D u_texture0; 
uniform sampler2D u_textureMosaic;

precision mediump float;

uniform int uMaskType;
uniform vec2 uMaskSize;
uniform vec2 uMaskCenter;
uniform vec2 uMaskSqr;
uniform vec2 uGradientDepth;
uniform int uInverseMask;

varying vec2 v_texCoords;
varying vec2 v_texAvgCoords;

void main(){


    vec4 v4Res = texture2D(u_textureMosaic, v_texAvgCoords);

    if(uMaskType == 0) // Box
    {
        vec2 v2Dis = abs(v_texCoords - uMaskCenter);
        vec2 v2Ratio = clamp((uMaskSize - v2Dis) / uGradientDepth, 0.0, 1.0);
        float fRatio = min(v2Ratio.x, v2Ratio.y);
        if(uInverseMask > 0)
            v4Res = mix(v4Res, texture2D(u_texture0, v_texCoords), fRatio);
        else
            v4Res = mix(texture2D(u_texture0, v_texCoords), v4Res, fRatio);
    }
    else //if(uMaskType == 1) // Circle
    {
        vec2 v2Dis = v_texCoords - uMaskCenter;
        v2Dis = v2Dis * v2Dis / uMaskSqr;
        float fRatio = (1.0 - (v2Dis.x + v2Dis.y)) / uGradientDepth.x;
        fRatio = clamp(fRatio, 0.0, 1.0);
        if(uInverseMask > 0)
            v4Res = mix(v4Res, texture2D(u_texture0, v_texCoords), fRatio);
        else
            v4Res = mix(texture2D(u_texture0, v_texCoords), v4Res, fRatio);
    }

  	gl_FragColor = v4Res;
}