
uniform sampler2D u_textureIntensity;
uniform sampler2D u_textureMask;

precision mediump float;

varying vec2 v_texCoords;

void main()
{
    float Intensity = texture2D(u_textureIntensity, v_texCoords).r;
    float Mask = texture2D(u_textureMask, v_texCoords).r;

    float relativeDiff = Intensity / Mask;

	if (relativeDiff < 1.01)
	{
        float multiply = (0.025 - min(0.025, (1.01 - relativeDiff))) / 0.025;
        Intensity *= multiply;
	}

    if(Intensity >= 0.00392156862745)
        gl_FragColor = vec4(1.0, 1.0, 1.0, 1.0);
    else
        gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);
}