uniform sampler2D u_texture0;

precision mediump float;

varying vec2 v_texCoords;

uniform float texelWidthOffset;
uniform float texelHeightOffset;
uniform float iDegree;

void main(void)
{
	vec2 singleStepOffset = vec2(texelWidthOffset, texelHeightOffset) * iDegree * 0.05;

	vec4 sum = vec4(0.0);

	sum += texture2D(u_texture0, v_texCoords) * 0.0834;
	sum += (texture2D(u_texture0, (v_texCoords + singleStepOffset * 1.0)) +
	        texture2D(u_texture0, (v_texCoords - singleStepOffset * 1.0))) * 0.0820;
	sum += (texture2D(u_texture0, (v_texCoords + singleStepOffset * 2.0)) +
	        texture2D(u_texture0, (v_texCoords - singleStepOffset * 2.0))) * 0.0779;
    sum += (texture2D(u_texture0, (v_texCoords + singleStepOffset * 3.0)) +
	        texture2D(u_texture0, (v_texCoords - singleStepOffset * 3.0))) * 0.0715;
    sum += (texture2D(u_texture0, (v_texCoords + singleStepOffset * 4.0)) +
	        texture2D(u_texture0, (v_texCoords - singleStepOffset * 4.0))) * 0.0634;
    sum += (texture2D(u_texture0, (v_texCoords + singleStepOffset * 5.0)) +
	        texture2D(u_texture0, (v_texCoords - singleStepOffset * 5.0))) * 0.0544;
    sum += (texture2D(u_texture0, (v_texCoords + singleStepOffset * 6.0)) +
	        texture2D(u_texture0, (v_texCoords - singleStepOffset * 6.0))) * 0.0451;
    sum += (texture2D(u_texture0, (v_texCoords + singleStepOffset * 7.0)) +
	        texture2D(u_texture0, (v_texCoords - singleStepOffset * 7.0))) * 0.0361;
    sum += (texture2D(u_texture0, (v_texCoords + singleStepOffset * 8.0)) +
	        texture2D(u_texture0, (v_texCoords - singleStepOffset * 8.0))) * 0.0279;

	gl_FragColor = sum;
}