#ifndef HAS_OFFSCREEN_TEXTURE
	#ifdef INPUT_IS_OES_TEXTURE
	#extension GL_OES_EGL_image_external : require
		uniform samplerExternalOES u_texture0;
	#else
		uniform sampler2D u_texture0;
	#endif
#else
uniform sampler2D u_texture0;
#endif

uniform sampler2D u_textureMask;

precision mediump float;

uniform int u_AdjustRange;

varying vec2 v_texCoords;

void main(){

	vec4 v4Src = texture2D(u_texture0, v_texCoords);

    vec2 v2MaskCoord = (v_texCoords - vec2(0.5)) * 0.83333333 + vec2(0.5);
	float fMask = texture2D(u_textureMask, v2MaskCoord).a;
	if(u_AdjustRange > 0)
    	fMask = clamp(fMask * 2.0 - 1.0, 0.0, 1.0);

    gl_FragColor = vec4(v4Src.rgb, v4Src.a * fMask);
}
