
uniform sampler2D u_texture0;

precision highp float;

uniform int u_Radius;
uniform vec2 u_TexelSize;

uniform float u_Inverse_1;
uniform float u_Inverse_2;


varying vec2 v_texCoords;

void main(){

    vec4 v4Sum = vec4(0.0, 0.0, 0.0, 0.0);

    for(int index = -u_Radius ; index <= u_Radius ; ++index)
        v4Sum += texture2D(u_texture0, v_texCoords + (u_TexelSize * float(index)));

    v4Sum /= float((u_Radius * 2) + 1);

//    v4Sum = vec4(sin((v4Sum.a - 0.5) * 3.14159265359) * 0.5 + 0.5); // linear -> sin curve

    v4Sum = (v4Sum - vec4(u_Inverse_1)) * u_Inverse_2;

    gl_FragColor = vec4(v4Sum);
}
