
uniform sampler2D u_textureMask;

precision mediump float;

uniform int u_Type;
uniform vec2 u_Aliasing;

varying vec2 v_texCoords;

void main(){

    if(u_Type == 0) // Line
    {
        if(v_texCoords.y > (0.5 + u_Aliasing.y))
            gl_FragColor = vec4(0.0);
        else if(v_texCoords.y > (0.5 - u_Aliasing.y))
            gl_FragColor = vec4((0.5 + u_Aliasing.y - v_texCoords.y) / u_Aliasing.y * 0.5);
        else
            gl_FragColor = vec4(1.0);
    }
    else if(u_Type == 1) // Parallel
    {
        float fAlpha = 1.0;
        if(v_texCoords.y < u_Aliasing.y)
            fAlpha = v_texCoords.y / u_Aliasing.y;
        else if(v_texCoords.y > (1.0 - u_Aliasing.y))
            fAlpha = (1.0 - v_texCoords.y) / u_Aliasing.y;

        gl_FragColor = vec4(fAlpha);
    }
    else if(u_Type == 2) // Box
    {
        float fAlpha = 1.0;
        if(v_texCoords.y < u_Aliasing.y)
            fAlpha = v_texCoords.y / u_Aliasing.y;
        else if(v_texCoords.y > (1.0 - u_Aliasing.y))
            fAlpha = (1.0 - v_texCoords.y) / u_Aliasing.y;

        if(v_texCoords.x < u_Aliasing.x)
            fAlpha = v_texCoords.x / u_Aliasing.x;
        else if(v_texCoords.x > (1.0 - u_Aliasing.x))
            fAlpha = (1.0 - v_texCoords.x) / u_Aliasing.x;

        gl_FragColor = vec4(fAlpha);
    }
    else if(u_Type == 3) // Circle
    {
        float fVal = ((v_texCoords.x - 0.5) * (v_texCoords.x - 0.5) + (v_texCoords.y - 0.5) * (v_texCoords.y - 0.5)) * 4.0;
        if(fVal > 1.0)
            gl_FragColor = vec4(0.0);
        else if(fVal > (1.0 - u_Aliasing.y))
            gl_FragColor = vec4((1.0 - fVal) / u_Aliasing.y);
        else
            gl_FragColor = vec4(1.0);
    }
    else if(u_Type == 4) // Image
    {
        vec4 v4Src = texture2D(u_textureMask, v_texCoords);
        gl_FragColor = vec4(dot(v4Src, vec4(0.299, 0.587, 0.114, 0.0)));
    }

}
